#ifndef _HAL_BSP_H_
#define _HAL_BSP_H_
#include "F28x_Project.h"
#include "BaseType.h"

#define Spi_a 0

#define Spi_b 1


#define BURST         (FIFO_LVL-1)    // burst size should be less than 8
#define TRANSFER      15              // [(MEM_BUFFER_SIZE/FIFO_LVL)-1]
#define FIFO_LVL      8               // FIFO Interrupt Level

#define ON   1
#define OFF  0

#define  EPWM1_TIMER_TBPRD   2500-1//Y/100000000(100M)=1/10000(10K)  Y=10000/2=5000
#define  EPWM1_CMPA      0
#define  EPWM1_CMPB      0

#define  EPWM2_TIMER_TBPRD   2500-1
#define  EPWM2_CMPA      0
#define  EPWM2_CMPB      0

#define  EPWM3_TIMER_TBPRD   832-1 //1250-1  //40k
#define  EPWM3_CMPA      2
#define  EPWM3_CMPB      832-2//1250-2

#define  EPWM4_TIMER_TBPRD   832-1  //60k
#define  EPWM4_CMPA      2//2
#define  EPWM4_CMPB      832-2//2

#define  EPWM5_TIMER_TBPRD  5000-1
#define  EPWM5_CMPA      0

#define  EPWM6_TIMER_TBPRD  5000-1
#define  EPWM6_CMPA      0


extern void HAL_Gpio(void);
extern void EPWM_Init(void);
extern void ECAP1_Init(void);
extern void ADC_Init(void);
extern void ADC_SOC_Init(void);
extern void SPI_FIFO_Init(void);
extern void DMA_Init(void);
extern void DAC_Init(void);
extern void PwmEnable(void);

extern void InitSpia(void);
extern void SendSpi_N(char dev,unsigned int *sndbuf,unsigned int cnt);
//extern void ReadSpi_N(char dev,unsigned int *rcvbuf,unsigned int cnt);
extern void ReadSpi_N(char dev,unsigned int *sndbuf,unsigned int *rcvbuf,unsigned int cnt);
#endif /* BSP_HAL_BSP_H_ */
