#ifndef _HAL_GOLBAL_H_
#define _HAL_GOLBAL_H_

#include "F28x_Project.h"
#include "BaseType.h"


typedef struct
{
   volatile Uint16 g_usBatHPro;
   volatile Uint16 g_usBatHArm;
   volatile Uint16 g_usBatHArmRec;
   volatile Uint16 g_usBatLPro;
   volatile Uint16 g_usBatLArm;
   volatile Uint16 g_usBatLArmRec;
   volatile Uint16 g_usBatLRec;
   volatile Uint16 g_usBusHPro;
   volatile Uint16 g_usBusHRec;
   volatile Uint16 g_usBusLPro;
   volatile Uint16 g_usBusLRec;
   volatile Uint16 g_usGridHPro;
   volatile Uint16 g_usGridHRec;
   volatile Uint16 g_usGridLPro;
   volatile Uint16 g_usGridLRec;

}RATEdPAR_T;

extern volatile RATEdPAR_T RatedPar;

typedef struct
{
  volatile Uint16 g_usAdcRefFlag;
  volatile Uint16 g_usAdcRefCnt;
  volatile Uint32 g_ulSumSampleData0;
  volatile Uint32 g_ulSumSampleData1;
  volatile Uint32 g_ulSumSampleData2;
  volatile Uint32 g_ulSumSampleData3;
  volatile Uint32 g_ulSumSampleData4;
  volatile Uint32 g_ulSumSampleData5;
  volatile Uint32 g_ulSumSampleData6;
  volatile Uint32 g_ulSumSampleData7;
  volatile Uint32 g_ulSumSampleData8;
  volatile Uint32 g_ulSumSampleData9;
  volatile Uint32 g_ulSumSampleData10;
  volatile Uint32 g_ulSumSampleData11;
  volatile Uint32 g_ulSumSampleData12;
  volatile Uint32 g_ulSumSampleData13;
  volatile Uint32 g_ulSumSampleData14;
  volatile Uint32 g_ulSumSampleData15;

  volatile int16 g_usSampleData0;
  volatile int16 g_usSampleData1;
  volatile int16 g_usSampleData2;
  volatile int16 g_usSampleData3;
  volatile int16 g_usSampleData4;

  volatile int16 g_usSampleData5;
  volatile int16 g_usSampleData6;
  volatile Uint16 g_usSampleData7;
  volatile int16 g_usSampleData8;
  volatile Uint16 g_usSampleData9;
  volatile int16 g_usSampleData10;
  volatile Uint16 g_usSampleData11;
  volatile int16 g_usSampleData12;
  volatile Uint16 g_usSampleData13;
  volatile Uint16 g_usSampleData14;
  volatile Uint16 g_usSampleData15;

  volatile Uint16 g_usInvCurrRef;
  volatile Uint16 g_usInvVolRef;
  volatile Uint16 g_usInvVdcRef;
  volatile Uint16 g_usBusVolRef;
  volatile Uint16 g_usGridVolRef;
  volatile Uint16 g_usLoadCurrRef;
  volatile Uint16 g_usGridCurrRef;
  volatile Uint16 g_usBusCurrRef;
  volatile Uint16 g_usPv1CurrRef;
  volatile Uint16 g_usPv2CurrRef;

  volatile int16 g_usInvCurr;
  volatile float32 g_usInvVol;
  volatile int16 g_usInvVdc;
  volatile int16 g_usBusVol;
  volatile int16 g_usGridVol;
  volatile int16 g_usLoadCurr;
  volatile int16 g_usGridCurr;
  volatile Uint16 g_usBatVol;
  volatile int16 g_usBusCurr;
  volatile Uint16 g_usTempChg;
  volatile int16 g_usPv1Curr;
  volatile Uint16 g_usPv1Vol;
  volatile int16 g_usPv2Curr;
  volatile Uint16 g_usPv2Vol;
  volatile Uint16 g_usTempDc;
  volatile Uint16 g_usTempInv;

  volatile Uint32 g_ulInvCurrAve;
  volatile Uint32 g_ulInvVolAve;
  volatile Uint32 g_ulGridVolAve;
  volatile Uint32 g_ulLoadCurrAve;
  volatile Uint32 g_ulGridCurrAve;

  volatile int16  g_usInvVdcAve;
  volatile int16  g_usBusVolAve;
  volatile int16  g_usBatVolAve;
  volatile int16  g_usBusCurrAve;
  volatile int16  g_usPv1CurrAve;
  volatile int16  g_usPv1VolAve;
  volatile int16  g_usPv2CurrAve;
  volatile int16  g_usPv2VolAve;


  volatile Uint16 g_usInvCurrRms;
  volatile Uint16 g_usInvVolRms;
  volatile Uint16 g_usInvVdcRms;
  volatile Uint16 g_usBusVolRms;
  volatile Uint16 g_usGridVolRms;
  volatile Uint16 g_usLoadCurrRms;
  volatile Uint16 g_usGridCurrRms;
  volatile Uint16 g_usBatVolRms;
  volatile int16 g_usBusCurrRms;
  volatile Uint16 g_usPv1CurrRms;
  volatile Uint16 g_usPv1VolRms;
  volatile Uint16 g_usPv2CurrRms;
  volatile Uint16 g_usPv2VolRms;
  volatile int16 g_usBatCurrRms;
  volatile Uint16 g_usFreq;
}ADC_T;

extern volatile ADC_T AdcSample;



typedef struct
{
    volatile  int16       g_usSpwmCnt;
    //volatile  float32     g_usGridVolUalArray[400];
    volatile  float32     g_usGridVolUbeArray[400];
    volatile  float32     g_usGridVolUal;
    volatile  float32     g_usGridVolUbe;
    volatile  float32     g_ufAngle;
    volatile  float32     g_ufAngleTemp;
    volatile  float32     g_ufGridVolUd;
    volatile  float32     g_ufGridVolUq;
    volatile  float32     g_ufUqRms;
    volatile  float32     g_usUq;
    volatile  float32     g_ufPllError0;
    volatile  float32     g_ufPllError1;
    volatile  float32     g_ufPllPid;
    volatile  float32     g_ufPllKp;
    volatile  float32     g_ufPllKi;
}PLL_T;

extern volatile  PLL_T InvPll;


typedef struct
{
    volatile  float32   SpwmData;
    volatile  float32   SpwmData0;
    volatile  Uint16    SpwmData1;
    volatile  Uint16    SpwmData2;
    volatile  int16     g_usSpwmCount;
    volatile  float32   g_usPeakVol;
    volatile  float32   g_usInvVolRef;
    volatile  float32   g_ufAngle;
    volatile  Uint16    g_usWorkMode;
    volatile  float32   g_usInvCurrRmsRef;
    volatile  float32   g_usInvCurrRef;
    volatile  float32   g_usBusVolRef;
}INVPOWER_T;

extern volatile INVPOWER_T InvPower;


typedef struct
{
    volatile  Uint16  g_usWorkMode;
    volatile  Uint16  g_usBusConstVal;
    volatile  Uint16  g_usBusChargPwm;
    volatile  Uint16  g_usTime10ms;
    volatile  Uint16  g_usTime10msFlag;
    volatile  Uint16  g_usTime100ms;
    volatile  Uint16  g_usTime1000ms;
    volatile  int16  PwmData0;
    volatile  Uint16  PwmData1;
}DCPOWER_T;

extern volatile DCPOWER_T DcPower;


typedef union
{
        volatile Uint16 flags;
        volatile  struct
        {
                volatile Uint16 g_usBatChargSoftStart:1;
                volatile Uint16 g_usBatHProFlag:1;
                volatile Uint16 g_usBatHAlmFlag:1;
                volatile Uint16 g_usBatLProFlag:1;
                volatile Uint16 g_usBatLAlmFlag:1;
                volatile Uint16 g_usBusHProFlag:1;
                volatile Uint16 g_usBusLProFlag:1;
                volatile Uint16 g_usBatNormalFlag:1;

                volatile Uint16 flag_bit8:1;
                volatile Uint16 flag_bit9:1;
                volatile Uint16 flag_bit10:1;
                volatile Uint16 flag_bit11:1;
                volatile Uint16 flag_bit12:1;
                volatile Uint16 flag_bit13:1;
                volatile Uint16 flag_bit14:1;
                volatile Uint16 flag_bit15:1;
        }bit;

}DCFLAG_T;

extern volatile DCFLAG_T DcFlag;

typedef union
{
        volatile Uint16 flags;
        volatile  struct
        {
                volatile Uint16 g_usSoftStart:1;
                volatile Uint16 g_usGridHProFlag:1;
                volatile Uint16 g_usGridLProFlag:1;
                volatile Uint16 g_usLedFlag:1;
                volatile Uint16 g_usPhaseLockFlag:1;
                volatile Uint16 flag_bit5:1;
                volatile Uint16 flag_bit6:1;
                volatile Uint16 flag_bit7:1;

                volatile Uint16 flag_bit8:1;
                volatile Uint16 flag_bit9:1;
                volatile Uint16 flag_bit10:1;
                volatile Uint16 flag_bit11:1;
                volatile Uint16 flag_bit12:1;
                volatile Uint16 flag_bit13:1;
                volatile Uint16 flag_bit14:1;
                volatile Uint16 flag_bit15:1;
        }bit;

}INVPOWERFLAG_T;

extern volatile INVPOWERFLAG_T InvPowerFlag;


#if 0
struct INVFLAG_BITS {

    volatile Uint16 flag_bit0:1;
    volatile Uint16 flag_bit1:1;
    volatile Uint16 flag_bit2:1;
    volatile Uint16 flag_bit3:1;
    volatile Uint16 flag_bit4:1;
    volatile Uint16 flag_bit5:1;
    volatile Uint16 flag_bit6:1;
    volatile Uint16 flag_bit7:1;

    volatile Uint16 flag_bit8:1;
    volatile Uint16 flag_bit9:1;
    volatile Uint16 flag_bit10:1;
    volatile Uint16 flag_bit11:1;
    volatile Uint16 flag_bit12:1;
    volatile Uint16 flag_bit13:1;
    volatile Uint16 flag_bit14:1;
    volatile Uint16 flag_bit15:1;

};

union INVFLAG_REG {
    Uint16  all;
    struct  INVFLAG_BITS  bit;
};

struct INVFLAG_REGS {

    union INVFLAG_REG   InvFlag;

};
#endif

typedef struct
{
   volatile Uint16 g_usPvDis;
}LCD_T;

extern volatile LCD_T LCD;



typedef struct
{
    volatile int16 g_sMpptTemp;
    volatile int16 g_sMpptTempA;
    volatile int16 g_usMpptRef;
    volatile Uint16 g_usMpptPvRef;
    volatile Uint16 g_usMpptStep;
    volatile Uint16 g_usBusVolRef;
    volatile Uint16 g_usPvOutRef;
    volatile Uint16 g_usPvPwmDuty;
    volatile Uint16 g_usBatPwmDuty;
    volatile Uint16 g_usChgPwmDuty;
    volatile Uint16 g_usPwmDuty;
    volatile Uint32 g_ulMpptPowerFirst;
    volatile Uint32 g_ulMpptPowerSecond;
    volatile Uint32 g_ulMpptPowerThird;
    volatile Uint16 g_usIref;
    volatile Uint16 g_usTime100us;
    volatile Uint16 g_usTime10ms;
    volatile Uint16 g_usTime10msFlag;
    volatile Uint16 g_usTime100ms;
    volatile Uint16 g_usTime100msFlag;
    volatile Uint16 g_usTime1000ms;
}MPPTPOWER_T;

extern volatile MPPTPOWER_T MpptPower;



typedef struct
{
  volatile Uint16 g_usChgSample;
  volatile Uint16 g_usChgSampleTemp;
  volatile Uint16 g_usLoadSample;
  volatile Uint16 g_usBusSample;
  volatile Uint16 g_usPvSample;
  volatile Uint16 g_usBatSample;
  volatile Uint16 g_usMpptTempSample;
  volatile Uint16 g_usBatTempSample;
  volatile Uint16 g_usLoadTempSample;
  volatile Uint16 g_usChgRef;
  volatile Uint16 g_usLoadRef;
  volatile Uint16 g_ucAdcFlag;
  volatile Uint16 g_ucRefFlag;
}MPPTADC_T;

extern volatile MPPTADC_T MpptAdc;

typedef union
{
        volatile Uint16 flags;
        volatile struct
        {
                volatile Uint16 g_ucBusHighFlag:1;
                volatile Uint16 g_ucBusLowFlag:1;
                volatile Uint16 g_ucPvHighFlag:1;
                volatile Uint16 g_ucPvLowFlag:1;
                volatile Uint16 g_ucPvRefFlag:1;
                volatile Uint16 g_ucMpptSoftFlag:1;
                volatile Uint16 g_ucMpptTempFlag:1;
                volatile Uint16 g_ucRunFlag:1;
                volatile Uint16 g_ucPvFlag:1;
                volatile Uint16 :1;
                volatile Uint16 :1;
                volatile Uint16 :1;
                volatile Uint16 :1;
                volatile Uint16 :1;
                volatile Uint16 :1;
                volatile Uint16 :1;
        }bit;

}MPPTFLAG_T;

extern volatile MPPTFLAG_T MpptFlag;


typedef struct  _PI{
        Uint16     SetPoint;               //输入:给定值
        Uint16     Feedback;               //输入:反馈值
//PID参数
        float32     T;                      //输入:周期
        float32     Ti;                     //输入:积分

        float32     a0;                     //计算值:a0 = Kp(1 + T/Ti + Td/T)
        float32     a1;                     //计算值:a1 = Kp(1 + 2Td/T)
        float32     a2;                     //计算值:a2 = Kp*Td/T

        int16       Ek;                     //计算值:Error[k]，当前误差
        int16       Ek_1;                   //计算值:Error[k-1]，
        int16       Ek_2;                   //计算值:Error[k-2]

        float32     Output;                 //计算值:PID输出值
        float32     Last_Output;            //计算值:上次输出值

        float32     Increment;              //增量值(输出PID值与上一时刻的PID值之差)

        float32     OutMax;                 //输入:PID输出最大值
        float32     OutMin;                 //输入:PID输出最小值

} MPPT_PI_TypeDef;


typedef struct  _PID{
    float32     SetPoint;               //输入:给定值
    float32     Feedback;               //输入:反馈值
//PID参数
        float32     T;                      //输入:周期
        float32     Ti;                     //输入:积分

        float32     a0;                     //计算值:a0 = Kp(1 + T/Ti + Td/T)
        float32     a1;                     //计算值:a1 = Kp(1 + 2Td/T)
        float32     a2;                     //计算值:a2 = Kp*Td/T

        float32       Ek;                     //计算值:Error[k]，当前误差  int16
        float32       Ek_1;                   //计算值:Error[k-1]，
        float32       Ek_2;                   //计算值:Error[k-2]

        float32     Output;                 //计算值:PID输出值
        float32     Last_Output;            //计算值:上次输出值

        float32     Increment;              //增量值(输出PID值与上一时刻的PID值之差)

        float32     OutMax;                 //输入:PID输出最大值
        float32     OutMin;                 //输入:PID输出最小值

} PID_TypeDef;


//*********** Structure Definition ********//
typedef struct{
    float32 osg_k;
    float32 osg_x;
    float32 osg_y;
    float32 osg_b0;
    float32 osg_b2;
    float32 osg_a1;
    float32 osg_a2;
    float32 osg_qb0;
    float32 osg_qb1;
    float32 osg_qb2;
}SPLL_1ph_SOGI_F_OSG_COEFF;

typedef struct{
    float32 B1_lf;
    float32 B0_lf;
    float32 A1_lf;
}SPLL_1ph_SOGI_F_LPF_COEFF;

typedef struct{
    float32   u[3];  // Ac Input
    float32   osg_u[3];
    float32   osg_qu[3];
    float32   u_Q[2];
    float32   u_D[2];
    float32   ylf[2];
    float32   fo; // output frequency of PLL
    float32   fn; //nominal frequency
    float32   theta[2];
    float32   cos;
    float32   sin;
    float32   delta_T;
    SPLL_1ph_SOGI_F_OSG_COEFF osg_coeff;
    SPLL_1ph_SOGI_F_LPF_COEFF lpf_coeff;
}SPLL_1ph_SOGI_F;

extern SPLL_1ph_SOGI_F spll1;

//---------------------------------------------------------------
#define  MACROSAMPLE_POINT      200//400//192  //输出开关频率改变此值也要改
#define  MACROAVER_CH_0         8
#define  MACROAVER_CH_0XS       0.005//0.0025f//0.0052f

//平均值累加和缓存
struct AVERAGE0_VALID{
   int  valid_buf[MACROSAMPLE_POINT];
   long  sum;//求和累加值
   unsigned int count;
};
extern struct AVERAGE0_VALID AverageValid_0[MACROAVER_CH_0];



#define  MACROSQUARE_CH         5
#define  MACROSQUARE_POINT      400//192 ////输出开关频率改变此值也要改
#define  MACROSQUARE_XS         0.0025f//0.0052f    // 1/MACROSQRT_POINT
//真有效值累加和缓存
struct SQUARE_VALID{
   int  valid_buf[MACROSQUARE_POINT];
   long sum;//求和累加值
   unsigned int count;
};
extern  struct SQUARE_VALID SquareValid[MACROSQUARE_CH];












#endif /* BSP_HAL_GOLBAL_H_ */
