/*-----------------------------------------------------------------------
 * 【函数】：void HAL_Interrupt.c(void)
 * 【参数】：
 * 【说明】：
 * 【其他】：
 * 【参考】：
----------------------------------------------------------------------- */

#include "Main.h"

static Uint16 s_usAdcRefCnt = 0;

volatile ADC_T AdcSample;

volatile INVPOWER_T InvPower;

static Uint16 s_usTzclrOstCnt=0;


/*-----------------------------------------------------------------------
 * 【函数】：__interrupt void adcC1ISR(void);
 * 【参数】：无
 * 【说明】：ADC外设中断的处理程序
 * 【其他】：注意需要加 __interrupt 关键字，加了的话编译器会自动处理 保持和恢
 *                     复特定的CPU寄存器状态（如果需要）且在人为清除中断组PIEACK位
 *                     后会自动使用IRET指令来返回；如果不加，则保持和恢复工作 以及 返
 *                     回工作需要人为处理。
 * 【参考】：详见开发文档的处理中断部分，或《TRM》P85
----------------------------------------------------------------------- */
//#pragma CODE_SECTION(ISR_Adcc1, ".TI.ramfunc");
__interrupt void ISR_Adcc1(void){

    //PWM_TEST_ON;
    AdccRegs.ADCINTFLGCLR.bit.ADCINT1 = 1;   // ADCC模块上的第一个中断

    if(AdcSample.g_usAdcRefFlag)
    {
        AdcSample.g_usSampleData0 = AdcaResultRegs.ADCRESULT0 - AdcSample.g_usInvCurrRef;//逆变电流
        AdcSample.g_usSampleData1 = AdcaResultRegs.ADCRESULT1 - AdcSample.g_usInvVolRef; //逆变电压
        AdcSample.g_usSampleData2 = AdcaResultRegs.ADCRESULT2 - AdcSample.g_usInvVdcRef; //直流分量
        AdcSample.g_usSampleData3 = AdcaResultRegs.ADCRESULT3;// - AdcSample.g_usBusVolRef; //BUS电压
        AdcSample.g_usSampleData4 = AdcaResultRegs.ADCRESULT4 - AdcSample.g_usGridVolRef;//市电输入

        AdcSample.g_usSampleData5 = AdcbResultRegs.ADCRESULT0 - AdcSample.g_usLoadCurrRef;//负载电流
        AdcSample.g_usSampleData6 = AdcbResultRegs.ADCRESULT1 - AdcSample.g_usGridCurrRef;//市电电流
        AdcSample.g_usSampleData7 = AdcbResultRegs.ADCRESULT2; //电池电压
        AdcSample.g_usSampleData8 = AdcbResultRegs.ADCRESULT3 - AdcSample.g_usBusCurrRef;//BUS电流
        AdcSample.g_usSampleData9 = AdcbResultRegs.ADCRESULT4;//充电温度

        AdcSample.g_usSampleData10 = AdccResultRegs.ADCRESULT0;//- AdcSample.g_usPv1CurrRef;//PV1电流
        AdcSample.g_usSampleData11 = AdccResultRegs.ADCRESULT1;//PV1电压
        AdcSample.g_usSampleData12 = AdccResultRegs.ADCRESULT2;//- AdcSample.g_usPv2CurrRef;//PV2电流
        AdcSample.g_usSampleData13 = AdccResultRegs.ADCRESULT3;//PV2电压
        AdcSample.g_usSampleData14 = AdccResultRegs.ADCRESULT4;//DC温度
        AdcSample.g_usSampleData15 = AdccResultRegs.ADCRESULT5;//逆变温度

/**************************************************************/
        InvPower.g_ufAngle = InvPower.g_usSpwmCount*0.01570975f;

        InvPower.SpwmData0 = 1800*__cos(InvPower.g_ufAngle);//cosf

        InvSpwm();
/************************************************************************/
        InvPower.g_usSpwmCount++;

        if(InvPower.g_usSpwmCount >= 400)
        {
            InvPower.g_usSpwmCount = 0;
        }

      }
    else
    {
        AdcSample.g_ulSumSampleData0 += AdcaResultRegs.ADCRESULT0;
        AdcSample.g_ulSumSampleData1 += AdcaResultRegs.ADCRESULT1;
        AdcSample.g_ulSumSampleData2 += AdcaResultRegs.ADCRESULT2;
        AdcSample.g_ulSumSampleData4 += AdcaResultRegs.ADCRESULT4;
        AdcSample.g_ulSumSampleData5 += AdcbResultRegs.ADCRESULT0;
        AdcSample.g_ulSumSampleData6 += AdcbResultRegs.ADCRESULT1;
        AdcSample.g_ulSumSampleData8 += AdcbResultRegs.ADCRESULT3;
        s_usAdcRefCnt++;

        if(s_usAdcRefCnt >= 400)
        {
            s_usAdcRefCnt = 0;

            AdcSample.g_usInvCurrRef = AdcSample.g_ulSumSampleData0*0.0025f;
            AdcSample.g_usInvVolRef = AdcSample.g_ulSumSampleData1*0.0025f;
            AdcSample.g_usInvVdcRef = AdcSample.g_ulSumSampleData2*0.0025f;
            AdcSample.g_usGridVolRef = AdcSample.g_ulSumSampleData4*0.0025f;
            AdcSample.g_usLoadCurrRef = AdcSample.g_ulSumSampleData5*0.0025f;
            AdcSample.g_usGridCurrRef = AdcSample.g_ulSumSampleData6*0.0025f;
            AdcSample.g_usBusCurrRef = AdcSample.g_ulSumSampleData8*0.0025f;

            AdcSample.g_ulSumSampleData0=0;
            AdcSample.g_ulSumSampleData1=0;
            AdcSample.g_ulSumSampleData2=0;
            AdcSample.g_ulSumSampleData4=0;
            AdcSample.g_ulSumSampleData5=0;
            AdcSample.g_ulSumSampleData6=0;
            AdcSample.g_ulSumSampleData8=0;

            AdcSample.g_usAdcRefCnt++;

            if(AdcSample.g_usAdcRefCnt>5)
            {
                AdcSample.g_usAdcRefCnt=0;
                AdcSample.g_usAdcRefFlag=1;
            }
        }
    }

    //PWM_TEST_OFF;

    if(1 == AdccRegs.ADCINTOVF.bit.ADCINT1)
    {
        AdccRegs.ADCINTOVFCLR.bit.ADCINT1 = 1;  //清除中断溢出
        AdccRegs.ADCINTFLGCLR.bit.ADCINT1 = 1;  // ADCC模块上的第一个中断
    }
    PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;     // 确认中断

}


/*-----------------------------------------------------------------------
 * 【函数】：void InvSpwm(void);
 * 【参数】：无
 * 【说明】：
 *
 *
 *
 * 【其他】：
 *
 * 【参考】：
----------------------------------------------------------------------- */
#pragma CODE_SECTION(InvSpwm, ".TI.ramfunc")

void InvSpwm(void)
{
    Uint16 temp1;

    if(InvPower.SpwmData0>=0)
    {
        temp1=InvPower.SpwmData0;
        if(temp1>EPWM1_TIMER_TBPRD)temp1=EPWM1_TIMER_TBPRD-1;

        EPwm1Regs.CMPA.bit.CMPA =EPWM1_TIMER_TBPRD-temp1;//2499-temp1;EPWM1_TIMER_TBPRD
        EPwm2Regs.CMPA.bit.CMPA =EPWM1_TIMER_TBPRD;
    }
    else
    {
        temp1=-InvPower.SpwmData0;
        if(temp1>EPWM1_TIMER_TBPRD)temp1=EPWM1_TIMER_TBPRD-1;
         EPwm1Regs.CMPA.bit.CMPA =temp1;
         EPwm2Regs.CMPA.bit.CMPA =0;
    }

    s_usTzclrOstCnt++;

    if(s_usTzclrOstCnt>2)
    {
    EALLOW;
    EPwm1Regs.TZCLR.bit.OST = 1;
    EPwm2Regs.TZCLR.bit.OST = 1;
    //EPwm1Regs.TZCLR.bit.INT = 1;
    EDIS;
    s_usTzclrOstCnt=5;
    }

}

/*-----------------------------------------------------------------------
 * 【函数】：void PwmEnable(void);
 * 【参数】：无
 * 【说明】：需要查阅《TRM》或开发文档相关说明
 *                     本代码文件中仅包含ePWM6模块的使用，其中ET开头的寄存器为事件
 *                     触发相关寄存器，用以触发ADC转换（SOC）
 *                     需要配置的寄存器有：
 * 【其他】：注意，EPWM设置时必须开着时钟（PCLKCR2）进行配置，否则配置
 *                     会失败
 * 【参考】：
----------------------------------------------------------------------- */
void PwmEnable(void)
{

    EALLOW;

    //EPwm1Regs.TZCLR.bit.OST = 1;
    //EPwm2Regs.TZCLR.bit.OST = 1;
    EPwm3Regs.TZCLR.bit.OST = 1;
    EPwm4Regs.TZCLR.bit.OST = 1;
    EPwm5Regs.TZCLR.bit.OST = 1;
    EPwm6Regs.TZCLR.bit.OST = 1;

    EDIS;


}




/*-----------------------------------------------------------------------
 * 【函数】：void PwmDisable(void);
 * 【参数】：无
 * 【说明】：需要查阅《TRM》或开发文档相关说明
 *                     本代码文件中仅包含ePWM6模块的使用，其中ET开头的寄存器为事件
 *                     触发相关寄存器，用以触发ADC转换（SOC）
 *                     需要配置的寄存器有：
 * 【其他】：注意，EPWM设置时必须开着时钟（PCLKCR2）进行配置，否则配置
 *                     会失败
 * 【参考】：
----------------------------------------------------------------------- */
void PwmDisable(void)
{
    EALLOW;

    EPwm1Regs.TZFRC.bit.OST  = 1;
    EPwm2Regs.TZFRC.bit.OST  = 1;
    EPwm3Regs.TZFRC.bit.OST  = 1;
    EPwm4Regs.TZFRC.bit.OST = 1;
    EPwm5Regs.TZFRC.bit.OST = 1;
    EPwm6Regs.TZFRC.bit.OST = 1;

    EDIS;
}




