/*-----------------------------------------------------------------------
 * 【函数】：void Main(void)
 * 【参数】：
 * 【说明】：发送接收48个字，头尾分别是0x5555,0xaaaa;
 * 【其他】：R77 主机dsp输出数据端，从机单片机接收端，R76是主机DSP接收数据端，从机单片机发送数据端
 * 【参考】：MPPT时间片放采样中断，运行主体在主程序，根据时间片来运行，保证主程序运行一循环不超过10ms
 * 正弦参考电压逆变输出,加入锁相程序
 * 由F28049_Project_B_Test_C_B演变过来
 *
 * PV电压低时，开始工作时会拉低PV电压值，会到保护电压以下产生PV低压保护，重启  20221206
 * MPPT基本调试完成 20221207
 * 加同步整流驱动，发现PWM3,PWM4不同步，修改PWM3,PWM4都和PWM1同步20221208
 * 完成PV充电部分调试
 * 解除跟PWM1,PWM2同步，要不然会烧坏升压管，同步出问题了，逆变波形要锁相周期在变化，调试并网和充电
 * 单极性倍频改为单极性普通调制，采样中断由100us变成50us
----------------------------------------------------------------------- */

#include "Main.h"
#if 0
unsigned int g_usReadData[50]={};

unsigned int g_usSendData[50]={};

int i = 0;
int j = 0;
unsigned int g_usSwCnt=0;

//extern float AdcTestInv[400];
extern float AdcTestRef[400];
extern float AdcTestSpwm[400];

unsigned int g_usTurnOnFlag=0;
unsigned int g_usBatBufFlag=0;

PID_TypeDef PiBatVol;
PID_TypeDef PiBatCurr;

extern volatile unsigned int g_usRelayFlag;

#endif

void main(void)
{
    float s_ufTemp1,s_ufTemp2;
    // Initialize device clock and peripherals
    InitSysCtrl();

    // Initialize PIE and clear PIE registers. Disables CPU interrupts. 
    DINT;
    InitPieCtrl();
    IER = 0x0000;
    IFR = 0x0000;

    // Initialize the PIE vector table with pointers to the shell Interrupt
    // Service Routines (ISR).
    InitPieVectTable();

    // Initialize GPIO and configure the GPIO pin as a push-pull output
    InitGpio();

    EPWM_Init();

    PwmEnable();

    HAL_Gpio();

    ADC_Init();

    ADC_SOC_Init();

    EALLOW;

    //PieVectTable.TIMER0_INT = &ISR_Timer0;

    PieVectTable.ADCC1_INT = &ISR_Adcc1;

    //PieVectTable.ECAP1_INT = &ISR_Ecap1;

    ////PieVectTable.EPWM1_TZ_INT = &ISR_Epwm1_Tz_Int;
    ////PieVectTable.EPWM1_INT = &ISR_Epwm1;

    //PieVectTable.SCIA_RX_INT = &ISR_SciaRx;
    EDIS;

    //Enable CPU int1 which is connected to TINT0
    IER |= M_INT1|M_INT2|M_INT4|M_INT9;//|M_INT3;

    // Enable ADCINT1 in the PIE: Group 1 interrupt 1
    //PieCtrlRegs.PIEIER1.bit.INTx7 = 1;//TIMER0
    PieCtrlRegs.PIEIER1.bit.INTx3 = 1;//ADCC1
    //PieCtrlRegs.PIEIER2.bit.INTx1 = 1;//TZ1
    //PieCtrlRegs.PIEIER3.bit.INTx1 = 1;//EPWM
    //PieCtrlRegs.PIEIER4.bit.INTx1 = 1;//ECAP1
    //PieCtrlRegs.PIEIER9.bit.INTx1 = 1;//Scia

    // Enable Global Interrupt (INTM) and realtime interrupt (DBGM)
    EINT;

    ERTM;
    InvPower.g_usSpwmCount=0;
    InvPower.SpwmData0=0;
    for(;;)
    {

    }
}
